﻿using Dynamicweb.Extensibility.Notifications;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    /// <summary>
    /// Sends an update to the ERP when the quantity of an order line is increased.
    /// </summary>
    /// <seealso cref="NotificationSubscriberBase" />
    [Subscribe(Ecommerce.Notifications.Ecommerce.Cart.Line.Increased)]
    public class OrderLineIncreased : NotificationSubscriberBase
    {
        /// <summary>
        /// Handles the notification.
        /// </summary>
        /// <param name="notification">The notification.</param>
        /// <param name="args">The args.</param>
        public override void OnNotify(string notification, NotificationArgs args)
        {
            if (args == null
                   || !(args is Ecommerce.Notifications.Ecommerce.Cart.Line.IncreasedArgs)
                   || !EnabledAndActive())
            {
                return;
            }

            var myArgs = (Ecommerce.Notifications.Ecommerce.Cart.Line.IncreasedArgs)args;

            if (CanCheckPrice)
            {
                SetProductInformation(myArgs.IncreasedLine.Product, myArgs.IncreasedLine.Quantity);
            }

            if (myArgs.Cart != null)
            {
                UpdateOrder(myArgs.Cart, "Line.Increased");
            }
        }
    }
}